using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using AnalyticsGadget.Models;
using EPiServer.Shell.Gadgets;

namespace AnalyticsGadget.Controllers
{
    [Gadget(Name = "Statistics - Browsers")]
    public class StatisticsBrowsersController : BaseStatisticsController
    {  
        protected override Report GetReport(string profileID, Timespan timespan)
        {
            ReportQuery query = new ReportQuery(profileID, MetricType.Visits);
            query.AddDimension(DimensionType.Browser);
            query.AddSortBy(MetricType.Visits, SortDirection.Descending);
            query.AddSortBy(DimensionType.Browser, SortDirection.Ascending);
            query.SetTimespan(timespan);
            return StatisticsHelper.GetReport(query);
        }
    }
}
